package tests;

import entities.EntityWithSRSM;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

public class TestOverride {
    
    protected EntityManagerFactory emf;
    private String testID;
    
    public TestOverride() {
    }
    
    public void test() {
        try {
            emf = Persistence.createEntityManagerFactory("sql-result-set-mapping");
            persistSomeEntities();
            assertProcessedSqlResultSetMappingIsFromXML();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private void persistSomeEntities() {
        EntityManager em = emf.createEntityManager();
        EntityTransaction tx = em.getTransaction();
        
        EntityWithSRSM axed1 = new EntityWithSRSM();
        axed1.setProjectsAxed("true");
        EntityWithSRSM axed2 = new EntityWithSRSM();
        axed2.setProjectsAxed("true");
        EntityWithSRSM retainedProject = new EntityWithSRSM();
        retainedProject.setProjectsAxed("false");
        
        tx.begin();
        em.persist(axed1);
        em.persist(axed2);
        em.persist(retainedProject);
        tx.commit();
    }
    
    private void assertProcessedSqlResultSetMappingIsFromXML() {
        EntityManager em = emf.createEntityManager();
        
        List result = em.createNamedQuery("Query1").getResultList();
        if ((result.get(0) instanceof EntityWithSRSM)){
            if (result.size() == 1)
                System.out.println("Query result contains 1 entity of Type EntityWithSRSM");
            else
                System.out.println("Expected Native Query to fetch count of retained projects, expected - 1, actual - " + result.size());
        } else {
            System.out.println("The query result is *NOT* an instance of Class EntityWithSRSM, Actual - " + result.get(0).getClass());
        }
        
    }
    
}
